<?php
include 'header.php';
include 'menu.php';
?>
<style type="text/css">
.typecho-post-option ul {
  list-style: none;
  border: 1px solid #D9D9D6;
  padding: 6px 12px;
  max-height: 240px;
  overflow: auto;
  background-color: #FFF;
  border-radius: 2px;
}
.typecho-post-option li {
  margin: 3px 0;
}
.typecho-custom-option .typecho-label{
	margin: 1em 0;
}
.typecho-menu-tabs{list-style:none;margin:0;padding:0;overflow:hidden;}
.typecho-menu-tabs li{float:left;margin-right:10px;}
.typecho-menu-tabs li a{display:block;height:28px;line-height:28px;padding:0 10px;border-radius:2px;background-color:#E9E9E6;color:#666;}
.typecho-menu-tabs li.active a,.typecho-menu-tabs li a:hover{background-color:#dbdbd6;text-decoration:none;}
.typecho-menu{background-color:#fff;border:1px solid #dedede;}
.typecho-menu-info{background-color:#f2f2f2;padding: 5px;}
.typecho-menu-list{padding: 5px;overflow:hidden;}

.dd { position: relative; display: block; margin: 0; padding: 0; max-width: 600px; list-style: none; font-size: 13px; line-height: 20px; }

.dd-list { display: block; position: relative; margin: 0; padding: 0; list-style: none; }
.dd-list .dd-list { padding-left: 30px; }
.dd-collapsed .dd-list { display: none; }

.dd-item,
.dd-empty,
.dd-placeholder { display: block; position: relative; margin: 0; padding: 0; min-height: 20px; font-size: 13px; line-height: 20px; }

.dd-handle,.dd-remove,.dd-setting{
	display: block; height: 30px; margin: 5px 0; padding: 5px 10px; color: #333; text-decoration: none; font-weight: bold; border: 1px solid #ccc;
	position: absolute; margin: 0; left: 0; top: 0; cursor: pointer; width: 30px; text-indent: 100%; white-space: nowrap; overflow: hidden;
    border: 1px solid #aaa;
    background: #ddd;
    background: -webkit-linear-gradient(top, #ddd 0%, #bbb 100%);
    background:    -moz-linear-gradient(top, #ddd 0%, #bbb 100%);
    background:         linear-gradient(top, #ddd 0%, #bbb 100%);
	-webkit-border-radius: 3px;
            border-radius: 3px;
    box-sizing: border-box; -moz-box-sizing: border-box;
    border-top-right-radius: 0;
    border-bottom-right-radius: 0;
}
.dd-remove{
	left:auto; right: 32px; top: 0;
    -webkit-border-radius: 0;
            border-radius: 0;
	display:none;
}
.dd-setting{
	left:auto; right: 0; top: 0; 
	border-top-left-radius: 0;
    border-bottom-left-radius: 0;
    
}
.dd-item:hover .dd-remove{
	display:block;
}
.dd-handle:before { content: '≡'; display: block; width: 100%; text-align: center; text-indent: 0; color: #fff; font-size: 18px; font-weight: normal; }
.dd-remove:before { content: '×'; display: block; width: 100%; text-align: center; text-indent: 0; color: #fff; font-size: 16px; font-weight: normal; }
.dd-setting:before { content: '▼'; display: block; width: 100%; text-align: center; text-indent: 0; color: #fff; font-size: 12px; font-weight: normal; }
.dd-handle:hover { background: #ddd; }

.dd-item > button { display: block; position: relative; cursor: pointer; float: left; width: 25px; height: 20px; margin: 5px 0 0 30px; padding: 0; text-indent: 100%; white-space: nowrap; overflow: hidden; border: 0; background: transparent; font-size: 12px; line-height: 1; text-align: center; font-weight: bold; }
.dd-item > button:before { content: '+'; display: block; position: absolute; width: 100%; text-align: center; text-indent: 0; }
.dd-item > button[data-action="collapse"]:before { content: '-'; }

.dd-placeholder,
.dd-empty { margin: 5px 0; padding: 0; min-height: 30px; background: #f2fbff; border: 1px dashed #b6bcbf; box-sizing: border-box; -moz-box-sizing: border-box; }
.dd-empty { border: 1px dashed #bbb; min-height: 100px; background-color: #e5e5e5;
    background-image: -webkit-linear-gradient(45deg, #fff 25%, transparent 25%, transparent 75%, #fff 75%, #fff),
                      -webkit-linear-gradient(45deg, #fff 25%, transparent 25%, transparent 75%, #fff 75%, #fff);
    background-image:    -moz-linear-gradient(45deg, #fff 25%, transparent 25%, transparent 75%, #fff 75%, #fff),
                         -moz-linear-gradient(45deg, #fff 25%, transparent 25%, transparent 75%, #fff 75%, #fff);
    background-image:         linear-gradient(45deg, #fff 25%, transparent 25%, transparent 75%, #fff 75%, #fff),
                              linear-gradient(45deg, #fff 25%, transparent 25%, transparent 75%, #fff 75%, #fff);
    background-size: 60px 60px;
    background-position: 0 0, 30px 30px;
}

.dd-dragel { position: absolute; pointer-events: none; z-index: 9999; }
.dd-dragel > .dd-item .dd-handle { margin-top: 0; }
.dd-dragel .dd-handle {
    -webkit-box-shadow: 2px 4px 6px 0 rgba(0,0,0,.1);
            box-shadow: 2px 4px 6px 0 rgba(0,0,0,.1);
}

.dd-content { display: block; height: 30px; margin: 5px 0; padding: 5px 10px 5px 40px; color: #333; text-decoration: none; font-weight: bold; border: 1px solid #ccc;
    background: #fafafa;
    background: -webkit-linear-gradient(top, #fafafa 0%, #eee 100%);
    background:    -moz-linear-gradient(top, #fafafa 0%, #eee 100%);
    background:         linear-gradient(top, #fafafa 0%, #eee 100%);
    -webkit-border-radius: 3px;
            border-radius: 3px;
    box-sizing: border-box; -moz-box-sizing: border-box;
}
.dd-content:hover { color: #2ea8e5; background: #fff; }

.dd-dragel > .dd-item > .dd-content { margin: 0; }
.dd-setdiv{
	display:none;
	margin-top:-5px;
	padding:5px;
	border:1px solid #ccc;
	border-top:none;
}
.dd-setdiv label{
	display:block;
	margin: 5px 0;
	font-weight: bold;
}
</style>
<?php
$navigation = json_decode($options->plugin('TeMenu')->navigation, true);
$slug = $request->get('slug','');
$currentNav = array();
if(!empty($slug) && isset($navigation[$slug])){
	$currentNav = $navigation[$slug];
}else{
	$slug = '';
}
?>
<div class="main">
	<div class="body container">
		<?php include 'page-title.php'; ?>
		<div class="row typecho-page-main">
			<div class="col-mb-12 col-tb-3 typecho-post-area" role="form">
                <section class="typecho-post-option">
					<label class="typecho-label"><?php _e('分类'); ?></label>
					<?php Typecho_Widget::widget('Widget_Metas_Category_List')->to($category); ?>
					<ul id="list-category">
						<?php while($category->next()): ?>
						<li><?php echo str_repeat('&nbsp;&nbsp;&nbsp;&nbsp;', $category->levels); ?>
						<input type="checkbox" id="category-<?php $category->mid(); ?>" data-name="<?php $category->name(); ?>" value="<?php $category->mid(); ?>" name="category[]"/>
						<label for="category-<?php $category->mid(); ?>"><?php $category->name(); ?></label></li>
						<?php endwhile; ?>
					</ul>
				</section>
				<p class="submit clearfix">
				<button type="button" class="btn primary btn-setmenu" data-type="category"><?php _e('添加到菜单'); ?></button>
				</p>
				<section class="typecho-post-option">
					<label class="typecho-label"><?php _e('页面'); ?></label>
					<?php Typecho_Widget::widget('Widget_Contents_Page_List')->to($pages); ?>
					<ul id="list-page">
						<?php while($pages->next()): ?>
						<li><input type="checkbox" id="pages-<?php $pages->cid(); ?>" data-name="<?php $pages->title(); ?>" value="<?php $pages->cid(); ?>" name="page[]"/>
						<label for="category-<?php $pages->cid(); ?>"><?php $pages->title(); ?></label></li>
						<?php endwhile; ?>
					</ul>
				</section>
				<p class="submit clearfix">
				<button type="button" class="btn primary btn-setmenu" data-type="page"><?php _e('添加到菜单'); ?></button>
				</p>
				<section class="typecho-post-option typecho-custom-option">
					<label for="menu-custom" class="typecho-label"><?php _e('自定义链接'); ?></label>
					<ul>
						<li>
							<label for="menu-custom" class="typecho-label"><?php _e('链接名称'); ?></label>
							<input id="menu-custom-name" type="text" value="" class="w-100 text" />
						</li>
						<li>
							<label for="menu-custom" class="typecho-label"><?php _e('链接地址'); ?></label>
							<input id="menu-custom-url" type="text" value="" class="w-100 text" placeholder="http://"/>
						</li>
					</ul>
				</section>
				<p class="submit clearfix">
				<button type="button" id="btn-setcustom" class="btn primary"><?php _e('添加到菜单'); ?></button>
				</p>
            </div>
			<div class="col-mb-12 col-tb-9">
				<ul class="typecho-menu-tabs">
					<?php if($navigation){ foreach($navigation as $k=>$v):?>
					<li <?php if($k==$slug){echo 'class="active"';}?>><a href="<?php echo Typecho_Common::url('extending.php?panel=TeMenu%2Fpanel.php&slug='.$k, $options->adminUrl)?>"><?php echo $v['title'];?></a></li>
					<?php endforeach;}?>
					<li><a href="<?php echo Typecho_Common::url('extending.php?panel=TeMenu%2Fpanel.php', $options->adminUrl)?>">+</a></li>
				</ul>
				<div class="typecho-menu">
					<div class="typecho-menu-info">
						<?php if(empty($slug)):?>
							<p>菜单名称 <input id="menu-title" type="text" value="" class="text" /></p>
							<p>菜单标识 <input id="menu-slug" type="text" value="" class="text" /></p>
						<?php else:?>
							菜单名称 <input id="menu-title" type="text" value="<?php echo $currentNav['title'];?>" class="text" />
							<input id="menu-slug" type="hidden" value="<?php echo $slug;?>" class="text" />
							<button type="button" id="btn-del" class="btn"><?php _e('删除'); ?></button>
						<?php endif;?>
						<button type="button" id="btn-save" class="btn primary"><?php empty($slug) ? _e('新增菜单') : _e('保存菜单'); ?></button>
					</div>
					<div class="typecho-menu-list">
						<div class="dd" id="menulist">
							<?php if(!empty($currentNav)){ echo TeMenu_Plugin::showNavigationDrag($currentNav['menu']);};?>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>

<?php
include 'copyright.php';
include 'common-js.php';
?>
<script src="<?php echo $options->pluginUrl.'/TeMenu/';?>jquery.nestable.js"></script>
<script type="text/javascript">
$(document).ready(function(){
	$('#menulist').nestable();
	$('.btn-setmenu').click(function(){
		if(!isSelectMenu()){
			return;
		}
		var that = $(this),type = that.data('type');
		var list = $('#list-'+type+' input');
		var arr = {},tmp={};
		$.each(list,function(k,v){
			tmp={};
			if($(v).is(':checked')){
				tmp['name'] = $(v).data('name');
				tmp['id'] = $(v).val();
				arr[k] = tmp;
				$(v).removeAttr('checked');
			}
		});
		$.each(arr,function(k,v){
			addMenu(type,v.name,v.id);
		});
	});
	
	$('#btn-setcustom').click(function(){
		if(!isSelectMenu()){
			return;
		}
		var url = $('#menu-custom-url'),name = $('#menu-custom-name');
		if(url.val()=='' || name.val()=='') return;
		addMenu('custom',name.val(),url.val());
		name.val('');
		url.val('');
	});
	$(document).on('click','.dd-item > .dd-remove',function(){
		$(this).parent().remove();
		saveMenu();
	});
	$(document).on('click','.dd-item > .dd-setting',function(){
		$(this).parent().find('.dd-setdiv').slideToggle();
	});

	$(document).on('propertychange input', '.dd-setdiv > input', function(){
		var that = $(this);
		if(that.hasClass('dd-name')){
			that.parents('.dd-item').data('name',that.val());
			that.parents('.dd-item').children('.dd-content').text(that.val());
		}
		if(that.hasClass('dd-url')){
			that.parents('.dd-item').data('id',that.val());
		}
		if(that.hasClass('dd-icon')){
			that.parents('.dd-item').data('icon',that.val());
		}
	});
	$(document).on('change','.dd-setdiv > input.dd-target',function(){
		var that = $(this);
		var target = that.prop("checked") ? 1 : 0;
		that.parents('.dd-item').data('target',target);
	});
	$('#btn-save').click(function(){
		saveMenu();
	});
	$('#btn-del').click(function(){
		saveMenu('del');
	});
	$('#menulist').on('change',function(){
		saveMenu();
	});
	function saveMenu(op){
		op = (undefined === op) ? 'save' : 'del';
		var slug = $('#menu-slug').val();
		if(slug=='') {
			alert('<?php _e('请填写菜单标识');?>');
			return;
		}
		var data = {};
		data['slug'] = slug;
		data['title'] = $('#menu-title').val();
		data['menu'] = $('#menulist').nestable('serialize');
		$.post('<?php $options->index('action/TeMenu');?>?op='+op,data).success(function(rs){　
			if(rs.msg!==undefined){
				alert(rs.msg);
			}
			if(rs.url!==undefined){
				window.location.href = rs.url;
			}
		});
	}
	function addMenu(type,name,data){
		var html = '';
		html +='<li class="dd-item" data-id="'+data+'" data-name="'+name+'" data-type="'+type+'" data-icon="" data-target="0">';
		html += '<div class="dd-handle">Drag</div><div class="dd-content">'+name+'</div><div class="dd-setting">Setting</div><div class="dd-remove">Remove</div>';
		html += '<div class="dd-setdiv"><label>名称</label><input class="w-100 text dd-name" type="text" value="'+name+'" />';
		if(type=='custom'){
			html += '<label>链接</label><input class="w-100 text dd-url" type="text" value="'+data+'" />';;
		}
		html += '<label>新窗口打开</label><input class="text dd-target" type="checkbox" value="1" />用新窗口打开链接';
		html += '<label>图标样式</label><input class="w-100 text dd-icon" type="text" value=""/>';
		html += '</div></li>';
		if($('#menulist > .dd-list').length>0){
			$(html).appendTo($('#menulist > .dd-list'));
		}else{
			$('<ol class="dd-list">'+html+'</div>').appendTo($('#menulist'));
		}
	}
	function isSelectMenu(){
		var slug = '<?php echo $slug;?>';
		if('' == slug){
			alert('<?php _e('请先选择一个待添加的菜单');?>');
			return false;
		}
		return true;
	}
});
</script>
<?php
include 'footer.php';
?>